# ![SmartFormat](https://raw.githubusercontent.com/scottrippey/SmartFormat.NET/main/SmartFormat_64x64.png)

### What is *SmartFormat*?

*SmartFormat* is a lightweight text templating library written in C#.

It can format various data sources into a string with a minimal, intuitive syntax similar to *string.Format*. All formatting takes place at runtime.

*SmartFormat* uses extensions to provide named placeholders, localization, pluralization, gender conjugation, as well as list and time formatting. Formatting extensions can be nested.

Custom source or formatter extensions can be added easily using simple interfaces.

### Features

* High performance with low memory footprint
* Minimal, intuitive syntax
* Formatting takes place exclusively at runtime
* Exact control of whitespace text output
* `string.Format` compatibility mode and `Smart.Format` enhanced mode
* Most common data sources work out-of-the-box
* Many built-in formatting extensions
* Custom formatting and source extensions are easy to integrate
* Comprehensive documentation: current Wiki, complete xmldoc

### Supported Frameworks
* .Net Framework 4.6.1 and later
* .Net Standard 2.0
* .Net Standard 2.1 and later for best optimizations

[![Paypal-Donations](https://img.shields.io/badge/Donate-PayPal-important.svg?style=flat-square)](https://www.paypal.com/donate?hosted_button_id=KSC3LRAR26AHN)
